<?php
/**
 * Created by PhpStorm.
 * 检测商户是否存在的简单demo checkMchExist示例接口
 * 将本目录放到www目录下 接口URL就为http://XXXXX/checkMchExist.php
 */

include_once "tools.php";
//公共参数
if (!isset($_POST['timestamp']) || !isset($_POST['channel_code']) || !isset($_POST['request_number'])){
    exit(json_encode(['code'=>10004,'message'=>'缺少公共参数']));
}
//业务参数
if (isset($_POST['company_name']) && isset($_POST['mobile'])){

    //接受参数
    $params = [
        'timestamp' => $_POST['timestamp'],
        'channel_code' => $_POST['channel_code'],
        'request_number' => $_POST['request_number'],
        'company_name' => $_POST['company_name'],//公司名
        'mobile' => $_POST['mobile'],//手机号
    ];
    $sign =  $_POST['sign'];//传递过来的sign
    //1.验证签名
    $key = getDbKeyByChannelCode($_POST['channel_code']);
    if (!$key){
        exit(json_encode(['code'=>10002,'message'=>'渠道编号不存在']));
    }
    $signString = Tools::buildParamStrOne($params);//组合字符串
    $figureSign = Tools::signOne($signString,$key);//求签名
    if ($sign != $figureSign){
        exit(json_encode(['code'=>10001,'message'=>'签名校验失败']));
    }
    //2.检查公司名及手机号是否存在软件商店铺表里
    $status = checkCompanyMobile($_POST['company_name'],$_POST['mobile']);
    exit(json_encode(['code'=>0,'message'=>'成功','timestamp'=>$_POST['timestamp'],'status'=>$status]));
}else{
    exit(json_encode(['code'=>10004,'message'=>'缺少业务参数']));
}


/** 验证channelCode且根据channelCode获取配置里(数据库或者配置文件)的key
 * @param $channelCode
 * @return string
 */
function getDbKeyByChannelCode($channelCode){

    $config = include_once 'config.php';
    if ($config['channel_code'] != $channelCode){
        return false;
    }
    return $config['key'];
}

/**
 * 检查公司手机号是否表里存在
 * @param $companyName
 * @param $mobile
 * @return int
 */
function checkCompanyMobile($companyName,$mobile){
    //todo 通过服务或者库表检查是否在自己的店铺表里
    //0商户手机号都不存在 1商户名称已存在且使用中2手机号已存在且使用中
    $status = 0;
    return $status;
}