<?php
/**
 * Created by PhpStorm.
 * 工具类 拼接和加密函数
 */

class  Tools {

    /**
     * 表单参数拼接
     * @param $requestParams
     * @return string
     */
    public static function buildParamStrOne($requestParams) {

        $paramStr = '';
        ksort($requestParams);
        if(is_array($requestParams) && count($requestParams) > 0){
            foreach($requestParams as $rk=>$rv){
                if($rk != 'sign'){
                    $paramStr .= $rk . '=' . $rv . '&';
                }
            }
            $paramStr = trim($paramStr,'&');
        }
        return $paramStr;
    }

    /** 求签名
     * @param $paramStr
     * @param $key
     * @return string
     */
    public static function signOne($paramStr,$key) {

        return strtoupper(md5($paramStr.'&key='.$key));
    }

    /** http请求
     * @param $url
     * @param $param
     * @param null $headerFlg
     * @return bool|mixed
     */
    public static function http_post($url,$param,$headerFlg=null){
        $oCurl = curl_init();
        if(stripos($url,"https://")!==FALSE){
            curl_setopt($oCurl, CURLOPT_SSL_VERIFYPEER, FALSE);
            curl_setopt($oCurl, CURLOPT_SSL_VERIFYHOST, false);
        }
        if (is_string($param)) {
            $strPOST = $param;
        } else {
            $aPOST = array();
            foreach($param as $key=>$val){
                $aPOST[] = $key."=".urlencode($val);
            }
            $strPOST =  join("&", $aPOST);
        }
        if(!empty($headerFlg)){
            $header[] = 'Content-Type:application/json';
            curl_setopt($oCurl,CURLOPT_HTTPHEADER,$header);
        }
        curl_setopt($oCurl, CURLOPT_URL, $url);
        curl_setopt($oCurl, CURLOPT_RETURNTRANSFER, 1 );
        curl_setopt($oCurl, CURLOPT_POST,true);
        curl_setopt($oCurl, CURLOPT_POSTFIELDS,$strPOST);
        $sContent = curl_exec($oCurl);
        $aStatus = curl_getinfo($oCurl);
        curl_close($oCurl);
        if(intval($aStatus["http_code"])==200){
            return $sContent;
        }else{
            //echo "http code:".$aStatus["http_code"]."\n";
            //var_dump($sContent);
            return false;
        }
    }

}




